%% log-likelihood for the BVAR with MA(1) errors
function llike = llike_MA1(psi,U,Sig)
[T n] = size(U);
Hpsi = speye(T) + psi*sparse(2:T,1:(T-1),ones(1,T-1),T,T); 
Utld = Hpsi\U;
CSig = chol(Sig)';
c = -T*n/2*log(2*pi) - T*sum(log(diag(CSig))) - n/2*log(1+psi^2);
tmp = (Utld/CSig');
s2 = sum(tmp.^2,2);
llike = c -.5*(s2(1)/(1+psi^2) + sum(s2(2:end)));
end
